<section class="container-fluid with-maxwidth chapter">
  <article class="article">
    <div class="row">
      <div class="padding-top-30 full-width text-left col-12 col-sm-6">
        <h2 class="article-title">Registro de Horas</h2>
      </div>
      <div class="padding-top-30 text-left text-sm-right col-12 col-sm-3">
      </div>
      <div class="padding-top-30 full-width text-sm-right text-left col-12 col-sm-3">
        <button mat-raised-button color="accent" class="btn-w-md" (click)="Nuevo()">Nuevo Día</button>
      </div>
    </div>

    <article class="article">
      <div class="box box-default">
        <div [hidden]="!editandoHora" class="box-body row">

          <div class="col-12 col-sm-2">
            <mat-form-field class="full-width">
              <input [(ngModel)]="diaActual" name="dia" class="full-width" matInput [matDatepicker]="picker"
                placeholder="FECHA" [formControl]="diaFC">
              <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
              <mat-datepicker #picker></mat-datepicker>
              <mat-error *ngIf="diaFC.invalid">La fecha es requerida.</mat-error>
            </mat-form-field>
          </div>

          <div class="col-4 col-sm-1 text-right">
            <h3 class="article-title">Inicio:</h3>
          </div>

          <div class="col-4 col-sm-1">
            <mat-form-field class="full-width">
              <button (click)="horasDesdeIntOnClick()" matSuffix mat-icon-button color="accent">
                <mat-icon class="material-icons">replay</mat-icon>
              </button>
              <input matTooltipPosition="above" matTooltip="Hora de Inicio de la jornada." matInput type="number"
                placeholder="H. Ini." [(ngModel)]="horasDesdeInt" [formControl]="horasDesdeIntFC">
              <mat-error *ngIf="horasDesdeIntFC.invalid">Debe ser un número entre 0 y 23</mat-error>
            </mat-form-field>
          </div>

          <div class="col-4 col-sm-1">
            <mat-form-field class="full-width">
              <button (click)="minutosDesdeIntOnClick()" matSuffix mat-icon-button color="accent">
                <mat-icon class="material-icons">replay</mat-icon>
              </button>
              <input matTooltipPosition="above" matTooltip="Minutos de Inicio de la jornada." matInput type="number"
                placeholder="M. Ini." [(ngModel)]="minutosDesdeInt" [formControl]="minutosDesdeIntFC">
              <mat-error *ngIf="minutosDesdeIntFC.invalid">Debe ser un número entre 0 y 59</mat-error>
            </mat-form-field>
          </div>

          <div class="col-4 col-sm-1 text-right">
            <h3 class="article-title">Fin:</h3>
          </div>

          <div class="col-4 col-sm-1">
            <mat-form-field class="full-width">
              <button (click)="horasHastaIntOnClick()" matSuffix mat-icon-button color="accent">
                <mat-icon class="material-icons">replay</mat-icon>
              </button>
              <input matTooltipPosition="above" matTooltip="Hora de Fin de la jornada." matInput type="number"
                placeholder="H. Fin" [(ngModel)]="horasHastaInt" [formControl]="horasHastaIntFC">
              <mat-error *ngIf="horasHastaIntFC.invalid">Debe ser un número entre 0 y 23</mat-error>
            </mat-form-field>
          </div>

          <div class="col-4 col-sm-1">
            <mat-form-field class="full-width">
              <button (click)="minutosHastaIntOnClick()" matSuffix mat-icon-button color="accent">
                <mat-icon class="material-icons">replay</mat-icon>
              </button>
              <input matTooltipPosition="above" matTooltip="Minutos de Fin de la jornada." matInput type="number"
                placeholder="M. Fin" [(ngModel)]="minutosHastaInt" [formControl]="minutosHastaIntFC">
              <mat-error *ngIf="minutosHastaIntFC.invalid">Debe ser un número entre 0 y 59</mat-error>
            </mat-form-field>
          </div>

          <div class="col-12 col-sm-4 text-right">
            <button
              [disabled]="diaFC.invalid || minutosDesdeIntFC.invalid || horasDesdeIntFC.invalid || minutosHastaIntFC.invalid || horasHastaIntFC.invalid"
              *ngIf="horaActual.id === undefined" mat-raised-button color="primary" class="btn-w-md"
              (click)="GuardarOnClick()">Guardar</button>
            <button
              [disabled]="diaFC.invalid || minutosDesdeIntFC.invalid || horasDesdeIntFC.invalid || minutosHastaIntFC.invalid || horasHastaIntFC.invalid"
              *ngIf="horaActual.id !== undefined" mat-raised-button color="primary" class="btn-w-md"
              (click)="GuardarOnClick()">Editar</button>
            <button *ngIf="horaActual.id !== undefined" mat-raised-button color="dark" class="btn-w-md"
              (click)="Cancelar()">Cancelar</button>
          </div>
        </div>

        <div id="rowAddHora" class="box-body row"
          [hidden]="editandoHora || horaActual === undefined || horaActual.id === undefined">

          <div class="col-12 col-sm-2">
            <span *ngIf="horaActual !== undefined && horaActual.dia !== undefined && horaActual.subtotal !== undefined">
              <b>{{ horaActual.dia }}</b>
              <br /> {{horaActual.subtotal | myTimePipe:'HH hs. mm min.'}} <mat-chip color="warn"><b>Dif.
                  {{GetSaldo()}}</b></mat-chip>
            </span>
            <button (click)="EditarHora()" mat-icon-button color="primary">
              <mat-icon class="material-icons">mode_edit</mat-icon>
            </button>
          </div>

          <div class="col-12 col-sm-3">
            <app-select-proyecto [object]="proyectoActual" (onChange)="ProyectoOnChange($event)" idModel="id"
              placeHolder="Proyecto" id="id" desc="nombre"></app-select-proyecto>
          </div>

          <div class="col-12 col-sm-3">
            <app-select-tarea [object]="tareaActual" (onChange)="TareaOnChange($event)" idModel="id" placeHolder="Tarea"
              id="id" desc="nombre"></app-select-tarea>
          </div>

          <div class="col-12 col-sm-1">
            <mat-form-field class="full-width">
              <button (click)="horasOnClick()" matSuffix mat-icon-button color="accent">
                <mat-icon class="material-icons">replay</mat-icon>
              </button>
              <input matInput type="number" placeholder="Horas" [(ngModel)]="horasInt" [formControl]="horasFC">
              <mat-error *ngIf="horasFC.invalid">Debe ser un número entre 0 y 23</mat-error>
            </mat-form-field>
          </div>

          <div class="col-12 col-sm-1">
            <mat-form-field class="full-width">
              <button (click)="minutosOnClick()" matSuffix mat-icon-button color="accent">
                <mat-icon class="material-icons">replay</mat-icon>
              </button>
              <input matInput type="number" placeholder="Minutos" [(ngModel)]="minutosInt" [formControl]="minutosFC">
              <mat-error *ngIf="minutosFC.invalid">Debe ser un número entre 0 y 59</mat-error>
            </mat-form-field>
          </div>
        </div>

        <div class="row" class="box-body row"
        [hidden]="editandoHora || horaActual === undefined || horaActual.id === undefined">
          <div class="col-12 col-sm-10">
            <mat-input-container class="full-width">
              <textarea matInput placeholder="Observación" value="" [(ngModel)]="observacion"></textarea>
            </mat-input-container>
          </div>
          <div class="col-12 col-sm-1 text-right">
            <button matTooltipPosition="above" matTooltip="Agregar Registro"
              [disabled]="minutosFC.invalid || horasFC.invalid || horaDetalleActual.proyecto === undefined || horaDetalleActual.tipoTarea === undefined"
              (click)="AgregarOnClick()" mat-raised-button color="primary">
              Agregar
            </button>
          </div>
        </div>

        <div class="box box-default table-box table-responsive mdl-shadow--2dp"
          *ngIf="!editandoHora && horaActual !== undefined && horaActual.id !== undefined && horaActual.horaDetalleList !== undefined && horaActual.horaDetalleList.length > 0">
          <table class="mdl-data-table">
            <thead>
              <tr>
                <th>Proyecto</th>
                <th>Tarea</th>
                <th>Observación</th>
                <th>Tiempo
                  <br /> Total: {{GetTotalCargado()}}</th>
                <th>
                  <mat-icon matTooltipPosition="above" matTooltip="Día completado correctamente."
                    *ngIf="horaActual !== undefined && horaActual.completa" color="accent" class="material-icons">done
                  </mat-icon>
                  <mat-icon matTooltipPosition="above" matTooltip="Día incompleto. Faltan registros de horas."
                    *ngIf="horaActual !== undefined && !horaActual.completa" color="warn" class="material-icons">error
                  </mat-icon>
                </th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor='let x of horaActual.horaDetalleList'>
                <td>
                  <span *ngIf="x.proyecto !== undefined">{{x.proyecto.nombre}}</span>
                </td>
                <td>
                  <span *ngIf="x.tipoTarea !== undefined">{{x.tipoTarea.nombre}}</span>
                </td>
                <td>
                  <span *ngIf="x.observacion !== undefined">{{x.observacion}}</span>
                </td>
                <td>{{x.duracion | myTimePipe:'HH hs. mm min.'}}</td>
                <td>
                  <button mat-icon-button color="warn">
                    <mat-icon class="material-icons" (click)="EliminarTiempo(x)">delete</mat-icon>
                  </button>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </article>

    <div class="row" *ngIf="isUserAdmin">
      <div class="col-sm-3 col-12 offset-sm-6">
        <app-select-colaborador [object]="colaboradorActual" (onChange)="ColaboradorOnChange($event)" idModel="id"
          placeHolder="Colaborador" id="id" desc="nombre"></app-select-colaborador>
      </div>
      <div class="col-sm-3 col-12">
        <mat-form-field class="full-width">
          <input [(ngModel)]="fDesde" (dateChange)="fDesdeOnChange($event)" class="full-width" matInput
            [matDatepicker]="pickerFDesde" placeholder="Fecha Desde">
          <mat-datepicker-toggle matSuffix [for]="pickerFDesde"></mat-datepicker-toggle>
          <mat-datepicker #pickerFDesde></mat-datepicker>
        </mat-form-field>
      </div>
    </div>
    <div class="row" *ngIf="!isUserAdmin">
      <div class="col-sm-3 col-12 offset-sm-9">
        <mat-form-field class="full-width">
          <input [(ngModel)]="fDesde" (dateChange)="fDesdeOnChange($event)" class="full-width" matInput
            [matDatepicker]="pickerFDesde" placeholder="Fecha Desde">
          <mat-datepicker-toggle matSuffix [for]="pickerFDesde"></mat-datepicker-toggle>
          <mat-datepicker #pickerFDesde></mat-datepicker>
        </mat-form-field>
      </div>
    </div>

    <div class="box box-default table-box table-responsive mdl-shadow--2dp">
      <table *ngIf="listaHoras !== undefined && listaHoras.length > 0" class="mdl-data-table">
        <thead>
          <tr>
            <th>Día</th>
            <th>H. Ent.</th>
            <th>H. Sal.</th>
            <th>Sub-Total</th>
            <th>Horas Cargadas</th>
            <th>Status</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <tr *ngFor='let x of listaHoras'>
            <td>{{x.dia}}</td>
            <td>{{x.horaIn}}</td>
            <td>{{x.horaOut}}</td>
            <td>{{x.subtotal | myTimePipe:'HH hs. mm min.'}}</td>
            <td>{{x.subtotalDetalles | myTimePipe:'HH hs. mm min.'}}</td>
            <td>
              <mat-icon matTooltipPosition="above" matTooltip="Día completado correctamente." *ngIf="x.completa"
                color="accent" class="material-icons">done</mat-icon>
              <mat-icon matTooltipPosition="above" matTooltip="Día incompleto. Faltan registros de horas."
                *ngIf="!x.completa" color="warn" class="material-icons">error</mat-icon>
            </td>
            <td>
              <button matTooltipPosition="above" matTooltip="Editar Día. Agregar/Quitar registro de horas."
                mat-icon-button color="primary" (click)="Editar(x)">
                <mat-icon class="material-icons">mode_edit</mat-icon>
              </button>
              <button *ngIf="isUserAdmin" matTooltipPosition="above" matTooltip="Eliminar Día." mat-icon-button
                color="warn">
                <mat-icon class="material-icons" (click)="Eliminar(x)">delete</mat-icon>
              </button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </article>
</section>